<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html
  xmlns="http://www.w3.org/1999/xhtml"
  xmlns:xi="http://www.w3.org/2001/XInclude"
  xmlns:xc="urn:xhtml-compiler"
  xc:news="yes"
  xml:lang="en">
<head>
  <title>State of the Flash - News - HTML Purifier</title>
  <xi:include href="common-meta.xml" xpointer="xpointer(/*/node())" />
</head>
<body>

<xi:include href="common-header.xml" xpointer="xpointer(/*/node())" />

<div id="main">
<h1 id="title">State of the Flash</h1>

<div id="content">
  <p>
    It is no exaggeration when I say that more than half of the support
    requests on HTML Purifier are for Flash.  I don't hold any especial
    fondness for the technology: from a purely security
    standpoint&mdash;that is, after all, what HTML Purifier is about,
    right?&mdash;the platform is an utterly byzantine, a twisty maze of
    flags and syntax and variations that make it really hard to
    whitelist properly.  I'd be much happier if no one used the damn
    software, and support for it shows in HTML Purifier; if you would
    like to support flash videos, you either:
  </p>
  <ul>
    <li>Hack around it manually using a filter which needs to be custom
    tailored for each website you wish to support, or</li>
    <li>Use SafeObject and SafeEmbed.</li>
  </ul>
  <p>
    From an end-user perspective, I've basically become convinced that
    the filter approach is not scalable; people expect to be able to
    include videos from any website.  Thus, work needs to be devoted to
    SafeObject and SafeEmbed to make them more robust.  Specifically, we
    need:
  </p>
  <ul>
    <li>Support for the <code>flashvars</code> parameter, which some
    flash players use in order to specify what content is being
    played,</li>
    <li>Support for Internet Explorer compatibility code, which gets
    specifically removed right now since we don't understand Internet
    Explorer conditional comments, and</li>
    <li>Better documentation about what is up with all of the different
    ways of setting up flash.</li>
  </ul>
  <p>
    I'm working on a patch as we speak to make flashvars happen.  I
    have no idea if this is going to introduce a security vulnerability,
    although my gut feeling is that anything a user could have done with
    a flashvar, they could have done with a malicious swf file.
  </p>
  <p>
    For compatibility code, there was a patch being bandied around on
    the forums for some time now.  I spent a few hours looking at it,
    and decided that the approach was wrong and am scrapping it.  I'll
    be adding a special hack to make Internet Explorer compatible code
    generated if we see an object tag.
  </p>
  <p>
    And of course, everyone loves documentation.  I'll be drawing up
    another document about using SafeObject and SafeEmbed effectively
    once these changes are released.
  </p>
  <p>
    Thank you all for being patient!
  </p>
</div>
</div>
</body>
</html>
